#include "vector.h"
#include <iostream>
using namespace std;

//      cpp-
vector::vector(int n)
{
	a = new int[vector::n = n];
	for (int i = 0; i < n; i++) a[i] = 0;
	// cout << n << endl;
}

vector::~vector()
{
	delete a;
	// cout << "deleted\n";
}

int vector::item(int i)
{
	if (i >= 0 && i < n) return a[i];
	else throw "Error in vector::item";
}

void vector::assign(int i, int x)
{
	if (i >= 0 && i < n) a[i] = x;
	else throw "Error in vector::assign";
}

int vector::NonZero()
{
	int k = 0;
	for (int i = 0; i < n; i++) if (a[i]) k++;
	return k;
}

void vector::operator=(vector& b) // c=b;
{
	if (n != b.n) throw "Error in =";
	for (int i = 0; i < n; i++) a[i] = b.a[i];
}

int & vector::operator[](int i)
{
	if (i < 0 || i >= n) throw "Error in []";
	return a[i];
}

void vector::operator()(int m)
{
	int* z = new int[m];
	for (int i = 0; i < m; i++)
		if (i < n) z[i] = a[i];
		else z[i] = 0;
	a = z;
	n = m;
}

// ============================

ostream& operator << (ostream & co, vector& v)
{
	for (int i = 0; i < v.n; i++) cout << v.a[i] << ' ';
	cout << endl;
	return cout;
}

